package cbg.xdoc;

import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import org.eclipse.jdt.core.IMethod;
import org.eclipse.jdt.core.IType;
import org.eclipse.jdt.core.JavaModelException;
import org.eclipse.jface.viewers.IBasicPropertyConstants;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerFilter;

/**
 * Insert the type's description here.
 * @see ViewerFilter
 */
public class CategoryFilter extends ViewerFilter {
	protected List tags = new LinkedList();
	public boolean isFilterProperty(Object element, String property) {
		return IBasicPropertyConstants.P_TEXT.equals(property) || 
			IBasicPropertyConstants.P_IMAGE.equals(property);
	}

	/**
	 * Insert the method's description here.
	 * @see ViewerFilter#select
	 */
	public boolean select(Viewer viewer, Object parentElement, Object element)  {
		try {
			if(tags == null || tags.size() == 0) return true;
			if(element instanceof IMethod) {
				IMethod method = (IMethod)element;
				IType cls = (IType)parentElement;
				if(cls.getSource() != null) {
					Categories category = AllCategories.getCategory(cls);
					for (Iterator iter = tags.iterator(); iter.hasNext();) {
						Object object = iter.next();
						if(object instanceof ValueSet) {
							ValueSet valueSet = (ValueSet)object;
							if(category.hasTag(method, valueSet.getName())) return true;
						} else {
							ValueSet.Value value = (ValueSet.Value)object;
							if(category.hasTagWithValue(method, value)) return true;
						}
					}
				}
			}
		} catch(JavaModelException jme) {
		    //ignore
		}
		return false;
	}
	public void showCategories(ISelection iSelection) {
		if(iSelection == null || !(iSelection instanceof IStructuredSelection)) return;
		tags.clear();
		Iterator sels = ((IStructuredSelection)iSelection).iterator();
		while(sels.hasNext()) {
			Object sel = sels.next();
			tags.add(sel);
		}
	}
}
