package cbg.xdoc;

import java.io.StringReader;
import java.util.HashMap;
import java.util.Map;

import org.eclipse.jdt.core.IType;
import org.eclipse.jdt.core.JavaModelException;

import com.thoughtworks.qdox.JavaDocBuilder;
import com.thoughtworks.qdox.model.JavaSource;

public class AllCategories {
	protected Map categories;
	protected JavaDocBuilder builder = new JavaDocBuilder();
	protected static AllCategories soleInstance = new AllCategories();
	public AllCategories() {
		super();
		categories = new HashMap();
	}
	public static AllCategories soleInstance() {
		return soleInstance;
	}
	public static void reparse(IType type) {
		soleInstance.reparseType(type);
	}
	public static Categories getCategory(IType clazz) {
		return soleInstance.getCategoryFor(clazz);
	}
	
	public void reparseType(IType type) {
		builder = new JavaDocBuilder();
		Categories category = (Categories)categories.get(type.getFullyQualifiedName());
		if(category == null) return;
		category.reparse(type);
	}
	public Categories getCategoryFor(IType type) {
		Categories category = (Categories)categories.get(type.getFullyQualifiedName());
		if(category == null) {
			category = Categories.newCategory(type);
			categories.put(type.getFullyQualifiedName(), category);
		}
		return category;
	}
	protected JavaSource getSource(IType clazz) {
		JavaSource source = null;
		try {
			builder.addSource(new StringReader(clazz.getSource()));
			source = builder.getSources()[0];
		} catch (JavaModelException e) {
		    //ignore
		}
		return source;
	}
}
